#pragma once
#include "url.h"
#include <stdbool.h>
#include <stddef.h>

typedef struct lm_pkg {
  struct lm_pkg *next;
  char          *name;
  char          *desc;
  char         **depends;
  char          *version;
  size_t         size;
} lm_pkg_t;

typedef struct lm_pool_info {
  char  *maintainer;
  char  *pubkey;
  size_t size;
  char  *file;
} lm_pool_info_t;

typedef struct lm_pool {
  struct lm_pool *next;
  lm_pool_info_t  info;
  lm_url_t        url;
  lm_pkg_t       *pkg;
  bool            available;
  char           *name;
} lm_pool_t;

typedef struct lm_ctx {
  lm_pool_t *pools; // pool list

  char *root;  // root path for package installtion
  char *temp;  // temp path
  char *data;  // package database path
  bool  debug; // is debug output enabled?
} lm_ctx_t;
